#ifdef __cplusplus
    #include <cstdlib>
#else
    #include <stdlib.h>
#endif
#ifdef __APPLE__
#include <SDL/SDL.h>
#else
#include <SDL.h>
#endif

#define NumSparks 10000

long RGBtoLong(Uint8,Uint8,Uint8);
int abs(int);

typedef struct {
    double x;
    double y;
    double vx;
    double vy;
    long RGB;
    int big;
    int active;
}Tspark;

int main ( int argc, char** argv )
{
Tspark Sparks[NumSparks];
int i,colour;
int Ticks;

    colour=100;
    for(i=0;i<NumSparks;i++){
        Sparks[i].active=0;
    }
    // initialize SDL video
    if(SDL_Init(SDL_INIT_VIDEO)<0)
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }

    // make sure SDL cleans up before exit
    atexit(SDL_Quit);

    // create a new window
    SDL_Surface* screen = SDL_SetVideoMode(1024,768,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
    if ( !screen )
    {
        printf("Unable to set 1024x768 video: %s\n", SDL_GetError());
        return 1;
    }

    //Ticks=SDL_GetTicks();

    // program main loop
    bool done = false;
    while (!done)
    {
        // message processing loop
        SDL_Event event;
        while (SDL_PollEvent(&event))
        {
            // check for messages
            switch (event.type)
            {
                // exit if the window is closed
            case SDL_QUIT:
                done = true;
                break;

                // check for keypresses
            case SDL_KEYDOWN:
                {
                    // exit if ESCAPE is pressed
                    if (event.key.keysym.sym == SDLK_ESCAPE)
                        done = true;
                    break;
                }
            } // end switch
        } // end of message processing

        while(Ticks+33>SDL_GetTicks());
        Ticks=SDL_GetTicks();

        //start some new sparks
        int count=0;
        while(count<NumSparks/100){
            //find a spark that is inactive
            for(i=0;i<NumSparks;i++){
                if(!Sparks[i].active)
                    break;
            }
            if(i<NumSparks){
                Sparks[i].active=65+rand()%20;
                Sparks[i].x=screen->w/2;
                Sparks[i].y=screen->h*7/8;
                Sparks[i].vx=(rand()%10000)-5000;
                Sparks[i].vx/=1200;
                Sparks[i].vy=(-rand()%600)-1100+abs(Sparks[i].vx)*25;
                Sparks[i].vy/=75;
                int col=colour+rand()%150;
                if(col>750)
                     col-=750;
                if(col<250)
                    Sparks[i].RGB=RGBtoLong(250,50,50);
                else if(col<500)
                    Sparks[i].RGB=RGBtoLong(50,255,50);
                else
                    Sparks[i].RGB=RGBtoLong(50,50,250);
                if(rand()>25000){
                    Sparks[i].RGB=RGBtoLong(255,255,255);
                }
                if(rand()>30000)
                    Sparks[i].big=1;
                else
                    Sparks[i].big=0;
            }
            count++;
        }

        if(colour--==0)
            colour=750;

        // DRAWING STARTS HERE
        // clear screen
        SDL_FillRect(screen, 0, SDL_MapRGB(screen->format, 0, 0, 0));

        SDL_LockSurface(screen);
        //move the active sparks and display them
        for(i=0;i<NumSparks;i++){
            if(Sparks[i].active){
                Sparks[i].x+=Sparks[i].vx;
                Sparks[i].vx*=0.98;
                //Sparks[i].vx+=0.15;
                Sparks[i].y+=Sparks[i].vy;
                Sparks[i].vy+=0.4;
                if(Sparks[i].y>=screen->h){
                    Sparks[i].active=0;
                }else{
                    if(Sparks[i].y>=0){
                        long*p=(long*)screen->pixels+(long)Sparks[i].y*screen->w+(long)Sparks[i].x;
                        *p++=Sparks[i].RGB;
                        if(Sparks[i].big){
                            *p--=Sparks[i].RGB;
                            *--p=Sparks[i].RGB;
                        }
                    }
                    Sparks[i].active--;
                }
            }
        }
        SDL_UnlockSurface(screen);

        // DRAWING ENDS HERE

        // finally, update the screen :)
        SDL_Flip(screen);
    } // end main loop

    // all is well ;)
    printf("Exited cleanly\n");
    return 0;
}

int abs(int num){
    return (num<0)?-num:num;
}


long RGBtoLong(Uint8 R,Uint8 G,Uint8 B){
    return (R*65536+G*256+B);
}
